/*
 * Copyright MapStruct Authors.
 *
 * Licensed under the Apache License version 2.0, available at http://www.apache.org/licenses/LICENSE-2.0
 */
/**
 * <p>
 * Contains "built-in methods" which may be added as private methods to a generated mapper. Built-in methods are an
 * alternative to primitive conversions in cases where those don't suffice, e.g. if several lines of code are required
 * for a conversion or an exception needs to be handled. Each built-in method has a corresponding template which
 * contains the source code of the method.
 * </p>
 */
package org.mapstruct.ap.internal.model.source.builtin;
